# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetDocumentationVersionResult',
    'AwaitableGetDocumentationVersionResult',
    'get_documentation_version',
    'get_documentation_version_output',
]

@pulumi.output_type
class GetDocumentationVersionResult:
    def __init__(__self__, description=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        A description about the new documentation snapshot.
        """
        return pulumi.get(self, "description")


class AwaitableGetDocumentationVersionResult(GetDocumentationVersionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDocumentationVersionResult(
            description=self.description)


def get_documentation_version(documentation_version: Optional[str] = None,
                              rest_api_id: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDocumentationVersionResult:
    """
    The ``AWS::ApiGateway::DocumentationVersion`` resource creates a snapshot of the documentation for an API. For more information, see [Representation of API Documentation in API Gateway](https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-documenting-api-content-representation.html) in the *API Gateway Developer Guide*.


    :param str documentation_version: The version identifier of the to-be-updated documentation version.
    :param str rest_api_id: The string identifier of the associated RestApi.
    """
    __args__ = dict()
    __args__['documentationVersion'] = documentation_version
    __args__['restApiId'] = rest_api_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:apigateway:getDocumentationVersion', __args__, opts=opts, typ=GetDocumentationVersionResult).value

    return AwaitableGetDocumentationVersionResult(
        description=pulumi.get(__ret__, 'description'))


@_utilities.lift_output_func(get_documentation_version)
def get_documentation_version_output(documentation_version: Optional[pulumi.Input[str]] = None,
                                     rest_api_id: Optional[pulumi.Input[str]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDocumentationVersionResult]:
    """
    The ``AWS::ApiGateway::DocumentationVersion`` resource creates a snapshot of the documentation for an API. For more information, see [Representation of API Documentation in API Gateway](https://docs.aws.amazon.com/apigateway/latest/developerguide/api-gateway-documenting-api-content-representation.html) in the *API Gateway Developer Guide*.


    :param str documentation_version: The version identifier of the to-be-updated documentation version.
    :param str rest_api_id: The string identifier of the associated RestApi.
    """
    ...
