# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from .. import outputs as _root_outputs

__all__ = [
    'GetConfiguredTableAssociationResult',
    'AwaitableGetConfiguredTableAssociationResult',
    'get_configured_table_association',
    'get_configured_table_association_output',
]

@pulumi.output_type
class GetConfiguredTableAssociationResult:
    def __init__(__self__, arn=None, configured_table_association_identifier=None, description=None, role_arn=None, tags=None):
        if arn and not isinstance(arn, str):
            raise TypeError("Expected argument 'arn' to be a str")
        pulumi.set(__self__, "arn", arn)
        if configured_table_association_identifier and not isinstance(configured_table_association_identifier, str):
            raise TypeError("Expected argument 'configured_table_association_identifier' to be a str")
        pulumi.set(__self__, "configured_table_association_identifier", configured_table_association_identifier)
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        pulumi.set(__self__, "description", description)
        if role_arn and not isinstance(role_arn, str):
            raise TypeError("Expected argument 'role_arn' to be a str")
        pulumi.set(__self__, "role_arn", role_arn)
        if tags and not isinstance(tags, list):
            raise TypeError("Expected argument 'tags' to be a list")
        pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter
    def arn(self) -> Optional[str]:
        """
        Returns the Amazon Resource Name (ARN) of the specified configured table association.

        Example: `arn:aws:cleanrooms:us-east-1:111122223333:configuredtable/a1b2c3d4-5678-90ab-cdef-EXAMPLE33333`
        """
        return pulumi.get(self, "arn")

    @property
    @pulumi.getter(name="configuredTableAssociationIdentifier")
    def configured_table_association_identifier(self) -> Optional[str]:
        """
        Returns the unique identifier of the specified configured table association.

        Example: `a1b2c3d4-5678-90ab-cdef-EXAMPLE33333`
        """
        return pulumi.get(self, "configured_table_association_identifier")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        A description of the configured table association.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="roleArn")
    def role_arn(self) -> Optional[str]:
        """
        The service will assume this role to access catalog metadata and query the table.
        """
        return pulumi.get(self, "role_arn")

    @property
    @pulumi.getter
    def tags(self) -> Optional[Sequence['_root_outputs.Tag']]:
        """
        An arbitrary set of tags (key-value pairs) for this cleanrooms collaboration.
        """
        return pulumi.get(self, "tags")


class AwaitableGetConfiguredTableAssociationResult(GetConfiguredTableAssociationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetConfiguredTableAssociationResult(
            arn=self.arn,
            configured_table_association_identifier=self.configured_table_association_identifier,
            description=self.description,
            role_arn=self.role_arn,
            tags=self.tags)


def get_configured_table_association(configured_table_association_identifier: Optional[str] = None,
                                     membership_identifier: Optional[str] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetConfiguredTableAssociationResult:
    """
    Represents a table that can be queried within a collaboration


    :param str configured_table_association_identifier: Returns the unique identifier of the specified configured table association.
           
           Example: `a1b2c3d4-5678-90ab-cdef-EXAMPLE33333`
    :param str membership_identifier: The unique ID for the membership this configured table association belongs to.
    """
    __args__ = dict()
    __args__['configuredTableAssociationIdentifier'] = configured_table_association_identifier
    __args__['membershipIdentifier'] = membership_identifier
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:cleanrooms:getConfiguredTableAssociation', __args__, opts=opts, typ=GetConfiguredTableAssociationResult).value

    return AwaitableGetConfiguredTableAssociationResult(
        arn=pulumi.get(__ret__, 'arn'),
        configured_table_association_identifier=pulumi.get(__ret__, 'configured_table_association_identifier'),
        description=pulumi.get(__ret__, 'description'),
        role_arn=pulumi.get(__ret__, 'role_arn'),
        tags=pulumi.get(__ret__, 'tags'))


@_utilities.lift_output_func(get_configured_table_association)
def get_configured_table_association_output(configured_table_association_identifier: Optional[pulumi.Input[str]] = None,
                                            membership_identifier: Optional[pulumi.Input[str]] = None,
                                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetConfiguredTableAssociationResult]:
    """
    Represents a table that can be queried within a collaboration


    :param str configured_table_association_identifier: Returns the unique identifier of the specified configured table association.
           
           Example: `a1b2c3d4-5678-90ab-cdef-EXAMPLE33333`
    :param str membership_identifier: The unique ID for the membership this configured table association belongs to.
    """
    ...
