# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'DetectorEventVariableDataSource',
    'DetectorEventVariableDataType',
    'DetectorEventVariableVariableType',
    'DetectorRuleExecutionMode',
    'DetectorRuleLanguage',
    'DetectorVersionStatus',
    'EventTypeEventVariableDataSource',
    'EventTypeEventVariableDataType',
    'EventTypeEventVariableVariableType',
    'VariableDataSource',
    'VariableDataType',
    'VariableType',
]


class DetectorEventVariableDataSource(str, Enum):
    """
    The data source of the event variable.

    Valid values: `EVENT | EXTERNAL_MODEL_SCORE`

    When defining a variable within a detector, you can only use the `EVENT` value for DataSource when the *Inline* property is set to true. If the *Inline* property is set false, you can use either `EVENT` or `MODEL_SCORE` for DataSource.
    """
    EVENT = "EVENT"


class DetectorEventVariableDataType(str, Enum):
    """
    The data type of the event variable.

    Valid values: `STRING | INTEGER | BOOLEAN | FLOAT`
    """
    STRING = "STRING"
    INTEGER = "INTEGER"
    FLOAT = "FLOAT"
    BOOLEAN = "BOOLEAN"


class DetectorEventVariableVariableType(str, Enum):
    """
    The type of event variable. For more information, see [Variable types](https://docs.aws.amazon.com/frauddetector/latest/ug/create-a-variable.html#variable-types) .
    """
    AUTH_CODE = "AUTH_CODE"
    AVS = "AVS"
    BILLING_ADDRESS_L1 = "BILLING_ADDRESS_L1"
    BILLING_ADDRESS_L2 = "BILLING_ADDRESS_L2"
    BILLING_CITY = "BILLING_CITY"
    BILLING_COUNTRY = "BILLING_COUNTRY"
    BILLING_NAME = "BILLING_NAME"
    BILLING_PHONE = "BILLING_PHONE"
    BILLING_STATE = "BILLING_STATE"
    BILLING_ZIP = "BILLING_ZIP"
    CARD_BIN = "CARD_BIN"
    CATEGORICAL = "CATEGORICAL"
    CURRENCY_CODE = "CURRENCY_CODE"
    EMAIL_ADDRESS = "EMAIL_ADDRESS"
    FINGERPRINT = "FINGERPRINT"
    FRAUD_LABEL = "FRAUD_LABEL"
    FREE_FORM_TEXT = "FREE_FORM_TEXT"
    IP_ADDRESS = "IP_ADDRESS"
    NUMERIC = "NUMERIC"
    ORDER_ID = "ORDER_ID"
    PAYMENT_TYPE = "PAYMENT_TYPE"
    PHONE_NUMBER = "PHONE_NUMBER"
    PRICE = "PRICE"
    PRODUCT_CATEGORY = "PRODUCT_CATEGORY"
    SHIPPING_ADDRESS_L1 = "SHIPPING_ADDRESS_L1"
    SHIPPING_ADDRESS_L2 = "SHIPPING_ADDRESS_L2"
    SHIPPING_CITY = "SHIPPING_CITY"
    SHIPPING_COUNTRY = "SHIPPING_COUNTRY"
    SHIPPING_NAME = "SHIPPING_NAME"
    SHIPPING_PHONE = "SHIPPING_PHONE"
    SHIPPING_STATE = "SHIPPING_STATE"
    SHIPPING_ZIP = "SHIPPING_ZIP"
    USERAGENT = "USERAGENT"


class DetectorRuleExecutionMode(str, Enum):
    """
    The rule execution mode for the rules included in the detector version.

    Valid values: `FIRST_MATCHED | ALL_MATCHED` Default value: `FIRST_MATCHED`

    You can define and edit the rule mode at the detector version level, when it is in draft status.

    If you specify `FIRST_MATCHED` , Amazon Fraud Detector evaluates rules sequentially, first to last, stopping at the first matched rule. Amazon Fraud dectector then provides the outcomes for that single rule.

    If you specifiy `ALL_MATCHED` , Amazon Fraud Detector evaluates all rules and returns the outcomes for all matched rules.
    """
    FIRST_MATCHED = "FIRST_MATCHED"
    ALL_MATCHED = "ALL_MATCHED"


class DetectorRuleLanguage(str, Enum):
    """
    The rule language.

    Valid Value: DETECTORPL
    """
    DETECTORPL = "DETECTORPL"


class DetectorVersionStatus(str, Enum):
    """
    The desired detector version status for the detector
    """
    DRAFT = "DRAFT"
    ACTIVE = "ACTIVE"


class EventTypeEventVariableDataSource(str, Enum):
    """
    The source of the event variable.

    Valid values: `EVENT | EXTERNAL_MODEL_SCORE`

    When defining a variable within a event type, you can only use the `EVENT` value for DataSource when the *Inline* property is set to true. If the *Inline* property is set false, you can use either `EVENT` or `MODEL_SCORE` for DataSource.
    """
    EVENT = "EVENT"


class EventTypeEventVariableDataType(str, Enum):
    """
    The data type of the event variable. For more information, see [Data types](https://docs.aws.amazon.com/frauddetector/latest/ug/variables.html#data-types) .
    """
    STRING = "STRING"
    INTEGER = "INTEGER"
    FLOAT = "FLOAT"
    BOOLEAN = "BOOLEAN"


class EventTypeEventVariableVariableType(str, Enum):
    """
    The type of event variable. For more information, see [Variable types](https://docs.aws.amazon.com/frauddetector/latest/ug/variables.html#variable-types) .
    """
    AUTH_CODE = "AUTH_CODE"
    AVS = "AVS"
    BILLING_ADDRESS_L1 = "BILLING_ADDRESS_L1"
    BILLING_ADDRESS_L2 = "BILLING_ADDRESS_L2"
    BILLING_CITY = "BILLING_CITY"
    BILLING_COUNTRY = "BILLING_COUNTRY"
    BILLING_NAME = "BILLING_NAME"
    BILLING_PHONE = "BILLING_PHONE"
    BILLING_STATE = "BILLING_STATE"
    BILLING_ZIP = "BILLING_ZIP"
    CARD_BIN = "CARD_BIN"
    CATEGORICAL = "CATEGORICAL"
    CURRENCY_CODE = "CURRENCY_CODE"
    EMAIL_ADDRESS = "EMAIL_ADDRESS"
    FINGERPRINT = "FINGERPRINT"
    FRAUD_LABEL = "FRAUD_LABEL"
    FREE_FORM_TEXT = "FREE_FORM_TEXT"
    IP_ADDRESS = "IP_ADDRESS"
    NUMERIC = "NUMERIC"
    ORDER_ID = "ORDER_ID"
    PAYMENT_TYPE = "PAYMENT_TYPE"
    PHONE_NUMBER = "PHONE_NUMBER"
    PRICE = "PRICE"
    PRODUCT_CATEGORY = "PRODUCT_CATEGORY"
    SHIPPING_ADDRESS_L1 = "SHIPPING_ADDRESS_L1"
    SHIPPING_ADDRESS_L2 = "SHIPPING_ADDRESS_L2"
    SHIPPING_CITY = "SHIPPING_CITY"
    SHIPPING_COUNTRY = "SHIPPING_COUNTRY"
    SHIPPING_NAME = "SHIPPING_NAME"
    SHIPPING_PHONE = "SHIPPING_PHONE"
    SHIPPING_STATE = "SHIPPING_STATE"
    SHIPPING_ZIP = "SHIPPING_ZIP"
    USERAGENT = "USERAGENT"


class VariableDataSource(str, Enum):
    """
    The source of the data.
    """
    EVENT = "EVENT"
    EXTERNAL_MODEL_SCORE = "EXTERNAL_MODEL_SCORE"


class VariableDataType(str, Enum):
    """
    The data type.
    """
    STRING = "STRING"
    INTEGER = "INTEGER"
    FLOAT = "FLOAT"
    BOOLEAN = "BOOLEAN"


class VariableType(str, Enum):
    """
    The variable type. For more information see https://docs.aws.amazon.com/frauddetector/latest/ug/create-a-variable.html#variable-types
    """
    AUTH_CODE = "AUTH_CODE"
    AVS = "AVS"
    BILLING_ADDRESS_L1 = "BILLING_ADDRESS_L1"
    BILLING_ADDRESS_L2 = "BILLING_ADDRESS_L2"
    BILLING_CITY = "BILLING_CITY"
    BILLING_COUNTRY = "BILLING_COUNTRY"
    BILLING_NAME = "BILLING_NAME"
    BILLING_PHONE = "BILLING_PHONE"
    BILLING_STATE = "BILLING_STATE"
    BILLING_ZIP = "BILLING_ZIP"
    CARD_BIN = "CARD_BIN"
    CATEGORICAL = "CATEGORICAL"
    CURRENCY_CODE = "CURRENCY_CODE"
    EMAIL_ADDRESS = "EMAIL_ADDRESS"
    FINGERPRINT = "FINGERPRINT"
    FRAUD_LABEL = "FRAUD_LABEL"
    FREE_FORM_TEXT = "FREE_FORM_TEXT"
    IP_ADDRESS = "IP_ADDRESS"
    NUMERIC = "NUMERIC"
    ORDER_ID = "ORDER_ID"
    PAYMENT_TYPE = "PAYMENT_TYPE"
    PHONE_NUMBER = "PHONE_NUMBER"
    PRICE = "PRICE"
    PRODUCT_CATEGORY = "PRODUCT_CATEGORY"
    SHIPPING_ADDRESS_L1 = "SHIPPING_ADDRESS_L1"
    SHIPPING_ADDRESS_L2 = "SHIPPING_ADDRESS_L2"
    SHIPPING_CITY = "SHIPPING_CITY"
    SHIPPING_COUNTRY = "SHIPPING_COUNTRY"
    SHIPPING_NAME = "SHIPPING_NAME"
    SHIPPING_PHONE = "SHIPPING_PHONE"
    SHIPPING_STATE = "SHIPPING_STATE"
    SHIPPING_ZIP = "SHIPPING_ZIP"
    USERAGENT = "USERAGENT"
