# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'MultiplexOutputDestination',
    'MultiplexOutputDestinationMultiplexMediaConnectOutputDestinationSettingsProperties',
    'MultiplexSettings',
    'MultiplexprogramMultiplexProgramPacketIdentifiersMap',
    'MultiplexprogramMultiplexProgramPipelineDetail',
    'MultiplexprogramMultiplexProgramServiceDescriptor',
    'MultiplexprogramMultiplexProgramSettings',
    'MultiplexprogramMultiplexVideoSettings',
]

@pulumi.output_type
class MultiplexOutputDestination(dict):
    """
    Multiplex MediaConnect output destination settings.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "multiplexMediaConnectOutputDestinationSettings":
            suggest = "multiplex_media_connect_output_destination_settings"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MultiplexOutputDestination. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MultiplexOutputDestination.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MultiplexOutputDestination.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 multiplex_media_connect_output_destination_settings: Optional['outputs.MultiplexOutputDestinationMultiplexMediaConnectOutputDestinationSettingsProperties'] = None):
        """
        Multiplex MediaConnect output destination settings.
        :param 'MultiplexOutputDestinationMultiplexMediaConnectOutputDestinationSettingsProperties' multiplex_media_connect_output_destination_settings: Multiplex MediaConnect output destination settings.
        """
        if multiplex_media_connect_output_destination_settings is not None:
            pulumi.set(__self__, "multiplex_media_connect_output_destination_settings", multiplex_media_connect_output_destination_settings)

    @property
    @pulumi.getter(name="multiplexMediaConnectOutputDestinationSettings")
    def multiplex_media_connect_output_destination_settings(self) -> Optional['outputs.MultiplexOutputDestinationMultiplexMediaConnectOutputDestinationSettingsProperties']:
        """
        Multiplex MediaConnect output destination settings.
        """
        return pulumi.get(self, "multiplex_media_connect_output_destination_settings")


@pulumi.output_type
class MultiplexOutputDestinationMultiplexMediaConnectOutputDestinationSettingsProperties(dict):
    """
    Multiplex MediaConnect output destination settings.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "entitlementArn":
            suggest = "entitlement_arn"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MultiplexOutputDestinationMultiplexMediaConnectOutputDestinationSettingsProperties. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MultiplexOutputDestinationMultiplexMediaConnectOutputDestinationSettingsProperties.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MultiplexOutputDestinationMultiplexMediaConnectOutputDestinationSettingsProperties.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 entitlement_arn: Optional[str] = None):
        """
        Multiplex MediaConnect output destination settings.
        :param str entitlement_arn: The MediaConnect entitlement ARN available as a Flow source.
        """
        if entitlement_arn is not None:
            pulumi.set(__self__, "entitlement_arn", entitlement_arn)

    @property
    @pulumi.getter(name="entitlementArn")
    def entitlement_arn(self) -> Optional[str]:
        """
        The MediaConnect entitlement ARN available as a Flow source.
        """
        return pulumi.get(self, "entitlement_arn")


@pulumi.output_type
class MultiplexSettings(dict):
    """
    A key-value pair to associate with a resource.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "transportStreamBitrate":
            suggest = "transport_stream_bitrate"
        elif key == "transportStreamId":
            suggest = "transport_stream_id"
        elif key == "maximumVideoBufferDelayMilliseconds":
            suggest = "maximum_video_buffer_delay_milliseconds"
        elif key == "transportStreamReservedBitrate":
            suggest = "transport_stream_reserved_bitrate"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MultiplexSettings. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MultiplexSettings.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MultiplexSettings.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 transport_stream_bitrate: int,
                 transport_stream_id: int,
                 maximum_video_buffer_delay_milliseconds: Optional[int] = None,
                 transport_stream_reserved_bitrate: Optional[int] = None):
        """
        A key-value pair to associate with a resource.
        :param int transport_stream_bitrate: Transport stream bit rate.
        :param int transport_stream_id: Transport stream ID.
        :param int maximum_video_buffer_delay_milliseconds: Maximum video buffer delay in milliseconds.
        :param int transport_stream_reserved_bitrate: Transport stream reserved bit rate.
        """
        pulumi.set(__self__, "transport_stream_bitrate", transport_stream_bitrate)
        pulumi.set(__self__, "transport_stream_id", transport_stream_id)
        if maximum_video_buffer_delay_milliseconds is not None:
            pulumi.set(__self__, "maximum_video_buffer_delay_milliseconds", maximum_video_buffer_delay_milliseconds)
        if transport_stream_reserved_bitrate is not None:
            pulumi.set(__self__, "transport_stream_reserved_bitrate", transport_stream_reserved_bitrate)

    @property
    @pulumi.getter(name="transportStreamBitrate")
    def transport_stream_bitrate(self) -> int:
        """
        Transport stream bit rate.
        """
        return pulumi.get(self, "transport_stream_bitrate")

    @property
    @pulumi.getter(name="transportStreamId")
    def transport_stream_id(self) -> int:
        """
        Transport stream ID.
        """
        return pulumi.get(self, "transport_stream_id")

    @property
    @pulumi.getter(name="maximumVideoBufferDelayMilliseconds")
    def maximum_video_buffer_delay_milliseconds(self) -> Optional[int]:
        """
        Maximum video buffer delay in milliseconds.
        """
        return pulumi.get(self, "maximum_video_buffer_delay_milliseconds")

    @property
    @pulumi.getter(name="transportStreamReservedBitrate")
    def transport_stream_reserved_bitrate(self) -> Optional[int]:
        """
        Transport stream reserved bit rate.
        """
        return pulumi.get(self, "transport_stream_reserved_bitrate")


@pulumi.output_type
class MultiplexprogramMultiplexProgramPacketIdentifiersMap(dict):
    """
    Packet identifiers map for a given Multiplex program.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "audioPids":
            suggest = "audio_pids"
        elif key == "dvbSubPids":
            suggest = "dvb_sub_pids"
        elif key == "dvbTeletextPid":
            suggest = "dvb_teletext_pid"
        elif key == "etvPlatformPid":
            suggest = "etv_platform_pid"
        elif key == "etvSignalPid":
            suggest = "etv_signal_pid"
        elif key == "klvDataPids":
            suggest = "klv_data_pids"
        elif key == "pcrPid":
            suggest = "pcr_pid"
        elif key == "pmtPid":
            suggest = "pmt_pid"
        elif key == "privateMetadataPid":
            suggest = "private_metadata_pid"
        elif key == "scte27Pids":
            suggest = "scte27_pids"
        elif key == "scte35Pid":
            suggest = "scte35_pid"
        elif key == "timedMetadataPid":
            suggest = "timed_metadata_pid"
        elif key == "videoPid":
            suggest = "video_pid"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MultiplexprogramMultiplexProgramPacketIdentifiersMap. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MultiplexprogramMultiplexProgramPacketIdentifiersMap.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MultiplexprogramMultiplexProgramPacketIdentifiersMap.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 audio_pids: Optional[Sequence[int]] = None,
                 dvb_sub_pids: Optional[Sequence[int]] = None,
                 dvb_teletext_pid: Optional[int] = None,
                 etv_platform_pid: Optional[int] = None,
                 etv_signal_pid: Optional[int] = None,
                 klv_data_pids: Optional[Sequence[int]] = None,
                 pcr_pid: Optional[int] = None,
                 pmt_pid: Optional[int] = None,
                 private_metadata_pid: Optional[int] = None,
                 scte27_pids: Optional[Sequence[int]] = None,
                 scte35_pid: Optional[int] = None,
                 timed_metadata_pid: Optional[int] = None,
                 video_pid: Optional[int] = None):
        """
        Packet identifiers map for a given Multiplex program.
        """
        if audio_pids is not None:
            pulumi.set(__self__, "audio_pids", audio_pids)
        if dvb_sub_pids is not None:
            pulumi.set(__self__, "dvb_sub_pids", dvb_sub_pids)
        if dvb_teletext_pid is not None:
            pulumi.set(__self__, "dvb_teletext_pid", dvb_teletext_pid)
        if etv_platform_pid is not None:
            pulumi.set(__self__, "etv_platform_pid", etv_platform_pid)
        if etv_signal_pid is not None:
            pulumi.set(__self__, "etv_signal_pid", etv_signal_pid)
        if klv_data_pids is not None:
            pulumi.set(__self__, "klv_data_pids", klv_data_pids)
        if pcr_pid is not None:
            pulumi.set(__self__, "pcr_pid", pcr_pid)
        if pmt_pid is not None:
            pulumi.set(__self__, "pmt_pid", pmt_pid)
        if private_metadata_pid is not None:
            pulumi.set(__self__, "private_metadata_pid", private_metadata_pid)
        if scte27_pids is not None:
            pulumi.set(__self__, "scte27_pids", scte27_pids)
        if scte35_pid is not None:
            pulumi.set(__self__, "scte35_pid", scte35_pid)
        if timed_metadata_pid is not None:
            pulumi.set(__self__, "timed_metadata_pid", timed_metadata_pid)
        if video_pid is not None:
            pulumi.set(__self__, "video_pid", video_pid)

    @property
    @pulumi.getter(name="audioPids")
    def audio_pids(self) -> Optional[Sequence[int]]:
        return pulumi.get(self, "audio_pids")

    @property
    @pulumi.getter(name="dvbSubPids")
    def dvb_sub_pids(self) -> Optional[Sequence[int]]:
        return pulumi.get(self, "dvb_sub_pids")

    @property
    @pulumi.getter(name="dvbTeletextPid")
    def dvb_teletext_pid(self) -> Optional[int]:
        return pulumi.get(self, "dvb_teletext_pid")

    @property
    @pulumi.getter(name="etvPlatformPid")
    def etv_platform_pid(self) -> Optional[int]:
        return pulumi.get(self, "etv_platform_pid")

    @property
    @pulumi.getter(name="etvSignalPid")
    def etv_signal_pid(self) -> Optional[int]:
        return pulumi.get(self, "etv_signal_pid")

    @property
    @pulumi.getter(name="klvDataPids")
    def klv_data_pids(self) -> Optional[Sequence[int]]:
        return pulumi.get(self, "klv_data_pids")

    @property
    @pulumi.getter(name="pcrPid")
    def pcr_pid(self) -> Optional[int]:
        return pulumi.get(self, "pcr_pid")

    @property
    @pulumi.getter(name="pmtPid")
    def pmt_pid(self) -> Optional[int]:
        return pulumi.get(self, "pmt_pid")

    @property
    @pulumi.getter(name="privateMetadataPid")
    def private_metadata_pid(self) -> Optional[int]:
        return pulumi.get(self, "private_metadata_pid")

    @property
    @pulumi.getter(name="scte27Pids")
    def scte27_pids(self) -> Optional[Sequence[int]]:
        return pulumi.get(self, "scte27_pids")

    @property
    @pulumi.getter(name="scte35Pid")
    def scte35_pid(self) -> Optional[int]:
        return pulumi.get(self, "scte35_pid")

    @property
    @pulumi.getter(name="timedMetadataPid")
    def timed_metadata_pid(self) -> Optional[int]:
        return pulumi.get(self, "timed_metadata_pid")

    @property
    @pulumi.getter(name="videoPid")
    def video_pid(self) -> Optional[int]:
        return pulumi.get(self, "video_pid")


@pulumi.output_type
class MultiplexprogramMultiplexProgramPipelineDetail(dict):
    """
    The current source for one of the pipelines in the multiplex.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "activeChannelPipeline":
            suggest = "active_channel_pipeline"
        elif key == "pipelineId":
            suggest = "pipeline_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MultiplexprogramMultiplexProgramPipelineDetail. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MultiplexprogramMultiplexProgramPipelineDetail.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MultiplexprogramMultiplexProgramPipelineDetail.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 active_channel_pipeline: Optional[str] = None,
                 pipeline_id: Optional[str] = None):
        """
        The current source for one of the pipelines in the multiplex.
        :param str active_channel_pipeline: Identifies the channel pipeline that is currently active for the pipeline (identified by PipelineId) in the multiplex.
        :param str pipeline_id: Identifies a specific pipeline in the multiplex.
        """
        if active_channel_pipeline is not None:
            pulumi.set(__self__, "active_channel_pipeline", active_channel_pipeline)
        if pipeline_id is not None:
            pulumi.set(__self__, "pipeline_id", pipeline_id)

    @property
    @pulumi.getter(name="activeChannelPipeline")
    def active_channel_pipeline(self) -> Optional[str]:
        """
        Identifies the channel pipeline that is currently active for the pipeline (identified by PipelineId) in the multiplex.
        """
        return pulumi.get(self, "active_channel_pipeline")

    @property
    @pulumi.getter(name="pipelineId")
    def pipeline_id(self) -> Optional[str]:
        """
        Identifies a specific pipeline in the multiplex.
        """
        return pulumi.get(self, "pipeline_id")


@pulumi.output_type
class MultiplexprogramMultiplexProgramServiceDescriptor(dict):
    """
    Transport stream service descriptor configuration for the Multiplex program.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "providerName":
            suggest = "provider_name"
        elif key == "serviceName":
            suggest = "service_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MultiplexprogramMultiplexProgramServiceDescriptor. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MultiplexprogramMultiplexProgramServiceDescriptor.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MultiplexprogramMultiplexProgramServiceDescriptor.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 provider_name: str,
                 service_name: str):
        """
        Transport stream service descriptor configuration for the Multiplex program.
        :param str provider_name: Name of the provider.
        :param str service_name: Name of the service.
        """
        pulumi.set(__self__, "provider_name", provider_name)
        pulumi.set(__self__, "service_name", service_name)

    @property
    @pulumi.getter(name="providerName")
    def provider_name(self) -> str:
        """
        Name of the provider.
        """
        return pulumi.get(self, "provider_name")

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> str:
        """
        Name of the service.
        """
        return pulumi.get(self, "service_name")


@pulumi.output_type
class MultiplexprogramMultiplexProgramSettings(dict):
    """
    Multiplex Program settings configuration.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "programNumber":
            suggest = "program_number"
        elif key == "preferredChannelPipeline":
            suggest = "preferred_channel_pipeline"
        elif key == "serviceDescriptor":
            suggest = "service_descriptor"
        elif key == "videoSettings":
            suggest = "video_settings"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MultiplexprogramMultiplexProgramSettings. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MultiplexprogramMultiplexProgramSettings.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MultiplexprogramMultiplexProgramSettings.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 program_number: int,
                 preferred_channel_pipeline: Optional['MultiplexprogramPreferredChannelPipeline'] = None,
                 service_descriptor: Optional['outputs.MultiplexprogramMultiplexProgramServiceDescriptor'] = None,
                 video_settings: Optional['outputs.MultiplexprogramMultiplexVideoSettings'] = None):
        """
        Multiplex Program settings configuration.
        :param int program_number: Unique program number.
        :param 'MultiplexprogramPreferredChannelPipeline' preferred_channel_pipeline: Indicates which pipeline is preferred by the multiplex for program ingest.
        :param 'MultiplexprogramMultiplexProgramServiceDescriptor' service_descriptor: Transport stream service descriptor configuration for the Multiplex program.
        :param 'MultiplexprogramMultiplexVideoSettings' video_settings: Program video settings configuration.
        """
        pulumi.set(__self__, "program_number", program_number)
        if preferred_channel_pipeline is not None:
            pulumi.set(__self__, "preferred_channel_pipeline", preferred_channel_pipeline)
        if service_descriptor is not None:
            pulumi.set(__self__, "service_descriptor", service_descriptor)
        if video_settings is not None:
            pulumi.set(__self__, "video_settings", video_settings)

    @property
    @pulumi.getter(name="programNumber")
    def program_number(self) -> int:
        """
        Unique program number.
        """
        return pulumi.get(self, "program_number")

    @property
    @pulumi.getter(name="preferredChannelPipeline")
    def preferred_channel_pipeline(self) -> Optional['MultiplexprogramPreferredChannelPipeline']:
        """
        Indicates which pipeline is preferred by the multiplex for program ingest.
        """
        return pulumi.get(self, "preferred_channel_pipeline")

    @property
    @pulumi.getter(name="serviceDescriptor")
    def service_descriptor(self) -> Optional['outputs.MultiplexprogramMultiplexProgramServiceDescriptor']:
        """
        Transport stream service descriptor configuration for the Multiplex program.
        """
        return pulumi.get(self, "service_descriptor")

    @property
    @pulumi.getter(name="videoSettings")
    def video_settings(self) -> Optional['outputs.MultiplexprogramMultiplexVideoSettings']:
        """
        Program video settings configuration.
        """
        return pulumi.get(self, "video_settings")


@pulumi.output_type
class MultiplexprogramMultiplexVideoSettings(dict):
    """
    The video configuration for each program in a multiplex.
    """
    def __init__(__self__):
        """
        The video configuration for each program in a multiplex.
        """
        pass


