# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

from enum import Enum

__all__ = [
    'ProactiveEngagementStatus',
    'ProtectionApplicationLayerAutomaticResponseConfigurationStatus',
    'ProtectionGroupAggregation',
    'ProtectionGroupPattern',
    'ProtectionGroupResourceType',
]


class ProactiveEngagementStatus(str, Enum):
    """
    If `ENABLED`, the Shield Response Team (SRT) will use email and phone to notify contacts about escalations to the SRT and to initiate proactive customer support.
    If `DISABLED`, the SRT will not proactively notify contacts about escalations or to initiate proactive customer support.
    """
    ENABLED = "ENABLED"
    DISABLED = "DISABLED"


class ProtectionApplicationLayerAutomaticResponseConfigurationStatus(str, Enum):
    """
    Indicates whether automatic application layer DDoS mitigation is enabled for the protection.
    """
    ENABLED = "ENABLED"
    DISABLED = "DISABLED"


class ProtectionGroupAggregation(str, Enum):
    """
    Defines how AWS Shield combines resource data for the group in order to detect, mitigate, and report events.
    * Sum - Use the total traffic across the group. This is a good choice for most cases. Examples include Elastic IP addresses for EC2 instances that scale manually or automatically.
    * Mean - Use the average of the traffic across the group. This is a good choice for resources that share traffic uniformly. Examples include accelerators and load balancers.
    * Max - Use the highest traffic from each resource. This is useful for resources that don't share traffic and for resources that share that traffic in a non-uniform way. Examples include Amazon CloudFront and origin resources for CloudFront distributions.
    """
    SUM = "SUM"
    MEAN = "MEAN"
    MAX = "MAX"


class ProtectionGroupPattern(str, Enum):
    """
    The criteria to use to choose the protected resources for inclusion in the group. You can include all resources that have protections, provide a list of resource Amazon Resource Names (ARNs), or include all resources of a specified resource type.
    """
    ALL = "ALL"
    ARBITRARY = "ARBITRARY"
    BY_RESOURCE_TYPE = "BY_RESOURCE_TYPE"


class ProtectionGroupResourceType(str, Enum):
    """
    The resource type to include in the protection group. All protected resources of this type are included in the protection group. Newly protected resources of this type are automatically added to the group. You must set this when you set `Pattern` to `BY_RESOURCE_TYPE` and you must not set it for any other `Pattern` setting.
    """
    CLOUDFRONT_DISTRIBUTION = "CLOUDFRONT_DISTRIBUTION"
    ROUTE53_HOSTED_ZONE = "ROUTE_53_HOSTED_ZONE"
    ELASTIC_IP_ALLOCATION = "ELASTIC_IP_ALLOCATION"
    CLASSIC_LOAD_BALANCER = "CLASSIC_LOAD_BALANCER"
    APPLICATION_LOAD_BALANCER = "APPLICATION_LOAD_BALANCER"
    GLOBAL_ACCELERATOR = "GLOBAL_ACCELERATOR"
