# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInstanceAccessControlAttributeConfigurationResult',
    'AwaitableGetInstanceAccessControlAttributeConfigurationResult',
    'get_instance_access_control_attribute_configuration',
    'get_instance_access_control_attribute_configuration_output',
]

@pulumi.output_type
class GetInstanceAccessControlAttributeConfigurationResult:
    def __init__(__self__, access_control_attributes=None, instance_access_control_attribute_configuration=None):
        if access_control_attributes and not isinstance(access_control_attributes, list):
            raise TypeError("Expected argument 'access_control_attributes' to be a list")
        pulumi.set(__self__, "access_control_attributes", access_control_attributes)
        if instance_access_control_attribute_configuration and not isinstance(instance_access_control_attribute_configuration, dict):
            raise TypeError("Expected argument 'instance_access_control_attribute_configuration' to be a dict")
        pulumi.set(__self__, "instance_access_control_attribute_configuration", instance_access_control_attribute_configuration)

    @property
    @pulumi.getter(name="accessControlAttributes")
    def access_control_attributes(self) -> Optional[Sequence['outputs.InstanceAccessControlAttributeConfigurationAccessControlAttribute']]:
        """
        Lists the attributes that are configured for ABAC in the specified IAM Identity Center instance.
        """
        return pulumi.get(self, "access_control_attributes")

    @property
    @pulumi.getter(name="instanceAccessControlAttributeConfiguration")
    def instance_access_control_attribute_configuration(self) -> Optional['outputs.InstanceAccessControlAttributeConfigurationProperties']:
        """
        The InstanceAccessControlAttributeConfiguration property has been deprecated but is still supported for backwards compatibility purposes. We recomend that you use  AccessControlAttributes property instead.
        """
        return pulumi.get(self, "instance_access_control_attribute_configuration")


class AwaitableGetInstanceAccessControlAttributeConfigurationResult(GetInstanceAccessControlAttributeConfigurationResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInstanceAccessControlAttributeConfigurationResult(
            access_control_attributes=self.access_control_attributes,
            instance_access_control_attribute_configuration=self.instance_access_control_attribute_configuration)


def get_instance_access_control_attribute_configuration(instance_arn: Optional[str] = None,
                                                        opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInstanceAccessControlAttributeConfigurationResult:
    """
    Resource Type definition for SSO InstanceAccessControlAttributeConfiguration


    :param str instance_arn: The ARN of the AWS SSO instance under which the operation will be executed.
    """
    __args__ = dict()
    __args__['instanceArn'] = instance_arn
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('aws-native:sso:getInstanceAccessControlAttributeConfiguration', __args__, opts=opts, typ=GetInstanceAccessControlAttributeConfigurationResult).value

    return AwaitableGetInstanceAccessControlAttributeConfigurationResult(
        access_control_attributes=pulumi.get(__ret__, 'access_control_attributes'),
        instance_access_control_attribute_configuration=pulumi.get(__ret__, 'instance_access_control_attribute_configuration'))


@_utilities.lift_output_func(get_instance_access_control_attribute_configuration)
def get_instance_access_control_attribute_configuration_output(instance_arn: Optional[pulumi.Input[str]] = None,
                                                               opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInstanceAccessControlAttributeConfigurationResult]:
    """
    Resource Type definition for SSO InstanceAccessControlAttributeConfiguration


    :param str instance_arn: The ARN of the AWS SSO instance under which the operation will be executed.
    """
    ...
